/*
 * Copyright 1999-2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.cocoon.components.treeprocessor;

/**
 * A named container node that just invokes its children.
 *
 * @version $Id: NamedContainerNode.java 359191 2005-12-27 08:51:54Z cziegeler $
 */
public class NamedContainerNode extends ContainerNode implements NamedProcessingNode {

    private String name;

    public NamedContainerNode(String name) {
        super(name);
        this.name = name;
    }

    public String getName() {
        return this.name;
    }
}
