/*
 * Copyright 1999-2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.cocoon.transformation;

import org.apache.cocoon.sitemap.SitemapModelComponent;
import org.apache.cocoon.xml.XMLPipe;

/**
 * A transformer is the zero to several intermediate points in a pipeline.
 * It "transforms" incoming XML arriving as SAX events from the pipeline
 * and sends modified XML as SAX events down the pipeline.
 *
 * @version $Id: Transformer.java 359513 2005-12-28 13:33:10Z cziegeler $
 */
public interface Transformer extends XMLPipe, SitemapModelComponent {

    String ROLE = Transformer.class.getName();

}
