/*
 * Copyright 2005 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.cocoon.util.location;

/**
 * A interface that should be implemented by objects knowning their location (i.e. where they
 * have been created from).
 * 
 * @since 2.1.8
 * @version $Id: Locatable.java 233343 2005-08-18 18:06:44Z sylvain $
 */
public interface Locatable {
    /**
     * Get the location of this object
     * 
     * @return the location
     */
    Location getLocation();
}
